using Microsoft.AspNetCore.Mvc;
using SchoolManagementSidekick;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SchoolManagementSidekick
{
    [ApiController]
    [EntityValidation]
    [Route("api/[controller]/[action]")]
    public class PersonController : ControllerBase
    {
        private readonly IPersonService _service;

        public PersonController(IPersonService service)
        {
            _service = service;
        }

        [HttpGet]
        public Task<Person?> GetAsync([FromQuery] int personId)
        {
            return _service.GetAsync(personId, HttpContext.RequestAborted);
        }

        [HttpGet]
        public Task<IEnumerable<Person>> GetListAsync()
        {
            return _service.GetListAsync(HttpContext.RequestAborted);
        }

        [HttpGet]
        public Task<PagedResult<Person>> GetPageAsync([FromQuery] PageParameter page)
        {
            return _service.GetPageAsync(page, HttpContext.RequestAborted);
        }

        [HttpGet]
        public async Task<IEnumerable<Person>> GetByFirstNameAsync([FromQuery] string firstName)
        {
            return await _service.FilterByFirstName(firstName, HttpContext.RequestAborted);
        }
    }
}
